% APRENDIZAJE AUTOMÁTICO (G. Pajares y J. M. de la Cruz, Eds.)
% Editorial: RA-MA
% Capítulo 11: Razonamiento Basado en Casos
% Autores: Ángela Ribeiro, Xavier P. Burgos Artizzu y Jesús M. Conesa Muñoz

% Método de segmentación S1
% Analysis of natural images processing for the extraction of agricultural
% elements. Image Vision Comput. 28(1): 138-149 (2010)
function imsegmentada = segmenta(im)

% PARÁMETROS FIJOS DE LA SEGMENTACIÓN
r = -0.884;
g = 1.262;
b = -0.311;
im = im*255;

% Se calculan el numero de filas y columnas de la imagen
[f,c,x] = size(im);

% Se construye una imagen auxiliar
aux = zeros(f,c); 

% Segmentación de vegetación usando método S1 y umbral variable
% según media de intensidades
aux = r*im(:,:,1)+g*im(:,:,2)+b*im(:,:,3);
aux= 255-aux;
aux(aux>255)=255;
aux(aux<0)=0;

umbral = mean(mean(aux))-5;

imsegmentada=aux;

imsegmentada(aux>=umbral)=0;
imsegmentada(aux<umbral)=255;
